use crate::relay::ws;
use crate::utils::structs::Context;
use std::net::SocketAddr;
use warp::{Rejection, Reply};

pub async fn ws_handler(
    ws: warp::ws::Ws,
    context: Context,
    real_client_ip: Option<SocketAddr>,
) -> Result<impl Reply, Rejection> {
    Ok(ws.on_upgrade(move |socket| ws::client_connection(socket, context, real_client_ip)))
}

pub async fn relay_config(header: String) -> Result<impl Reply, Rejection> {
    if header != "application/nostr+json" {
        Err(warp::reject::not_found())
    } else {
        let res = serde_json::json!({
            "name": "Zhitno.st",
            "description": "Very *special* nostr relay",
            "software": "sneedstr",
            "version": "0.1.0"
        });
        Ok(warp::reply::json(&res))
    }
}
